#include "server/GameServer.h"
#include "server/network/Server.h"

GameServer::GameServer()
{
}

GameServer::~GameServer()
{
}

void GameServer::stop()
{
    isRunning = false;
}

void GameServer::start(unsigned short port, unsigned short maxClients)
{
    std::cout << port << std::endl;
    Server server(port, maxClients);
    server.start(this);
    
    isRunning = true;
    while(isRunning)
    {
        cout << "> ";
        string command;
        getline(cin, command, '\n');
        if(command == "q")
        {
            break;
        }
        commandManager.execute(*this, command);
    }
    
    server.stop();
}

void GameServer::onFullServerClientConnect(int socket)
{
    string s = "sorry, the server is full";
    Stream answer;
    answer.write(s.data(), s.length());
    answer.sendToSocket(socket);
}

void GameServer::onClientConnect(int socket)
{
    cout << socket << " has connected" << endl;
    
    string s = "Welcome to the server.";
    Stream answer;
    answer.write(s.data(), s.length());
    answer.sendToSocket(socket);
}

void GameServer::onClientPackage(int socket, Stream& in)
{
    string s = "";
    while(in.hasData())
    {
        s = in.readChar() + s;
    }

    Stream answer;
    answer.write(s.data(), s.length());
    answer.sendToSocket(socket);
}

void GameServer::onClientDisconnect(int socket)
{
    cout << socket << " has disconnected" << endl;
    
    string s = "Bye.";
    Stream answer;
    answer.write(s.data(), s.length());
    answer.sendToSocket(socket);
}
